;*************************************************************** 
;* 
;* Port kezelst bemutat program
;* 
;* A D port als 4 bitjn lv 4 nyomgomb kezeli (active low)
;* a C port fels 4 bitjn lv LED-eket (active high)
;* 
;*************************************************************** 
;* 
;*  Kszitette: 
;*  Csoport:
;*  Dtum: 
;* 
;*************************************************************** 
 
.include "m128def.inc"  		; ATmega128 defincis fjl
 
;*************************************************************** 
;* Konstansok 
;*************************************************************** 
.equ	BTmask = 0x0F			; Gombok az als ngy biten
.equ	LEDmask = 0xF0 			; LED-ek a fels ngy biten

;*************************************************************** 
;* Vltozk
;*************************************************************** 
.def	mpr1 = R16				;  ltalnos felhasznls regiszterek
.def	mpr2 = R17

;*************************************************************** 
;* Megszakts vektorok
;*************************************************************** 
.cseg 
.org 0x0000      				; Kdszegmens kezdcme //Ezutn jn a megszakts tbla az 1-es cmtl kezdden

		jmp	init				; Reset vektor 

.org 0x0047						;megszakts tbla vge
;*****************************************************************************
;* Inicializls
;*****************************************************************************

;***** Stack inicializlsa *****

init:	ldi		mpr1,LOW(RAMEND)	; RAMEND = RAM vgcme
		out		SPL,mpr1			; (ld."m128def.inc") 
		ldi		mpr1,HIGH(RAMEND)
		out		SPH,mpr1

;*****************************************************************************
;* Fprogram
;*****************************************************************************		

main:
		ldi		mpr1,BTmask

		/////////////// plda, hogy mit csinl a ~ jel (alt gr 1)
		ldi		R20,~0x0F			; a ~ jel negcit jelent
		ldi		R21,0x0F
		//////////////////////////////////////////////////////////

		ldi		mpr1,LEDmask
		out		DDRC,mpr1
loop:	
		in		mpr1,PIND			;kiolvassa a D port llaptt betlti mpr1-be
		swap	mpr1				;felcserli az als ngy bitet a fels ngy bitre s fordtva
		com		mpr1				;egyes komplemens kdot kszt // neglja a regiszter rtkt
		andi	mpr1,~BTmask		;bitenknti s kapcsolat egy regiszter s egy konstans kztt. az eredmny az mpr1-be kerl 
									;megjegyzs: az and ugyan ezt csinlja csak ott kt regisztert kell megadni

		in		mpr2,PORTC			;beolvassa a C port llapott s betlti mpr2-be
		andi	mpr2,~LEDmask		;bitenknti s kapcsolat , eredmny mpr2-be
		or		mpr1,mpr2			;bitenknti or kapcsolat. eredmny mpr1-be kerl
		out		PORTC,mpr1			; kirakja a c portra az mpr1 rtkt


		jmp		loop;			; Vgtelen hurok
		
;*****************************************************************************
;* Szubrutinok
;*****************************************************************************

;*****************************************************************************
;* Megszakts kezel rutinok
;*****************************************************************************

;*****************************************************************************
;* Adatok
;*****************************************************************************
